;****************************************************************************
;*
;*            (c) ATMEL-Wireless and Microcontrollers 2001 
;*
;*
;*****************************************************************************/

 NAME FLASH_LIB; 
;*A51**************************************************************************
; FILE_NAME         : FLASH_LIB.a51                                            
;------------------------------------------------------------------------------
; FILE_CREATED_BY   : Jean-sebastien Berthy && Raphal L'etendu
; FILE_CREATION_DATE: 14/01/00  
; MODIFIED_BY       : Raphal Letendu
; MODIFICATION_DATA : 29/08/2001                                               
;------------------------------------------------------------------------------
; FILE_PURPOSE: low level functions for API  
;******************************************************************************

USING 0

PUBLIC ASM_MOV_R1_A
PUBLIC __API_FLASH_ENTRY_POINT
PUBLIC __API_FILL_FF_PAGE

AUXR1 EQU 0A2h
FCON  EQU 0D1h

START SEGMENT CODE
RSEG START

;*****************************************************************************
; FUNCTION_NAME: ASM_MOV_A_R1
;*****************************************************************************
ASM_MOV_R1_A:
  Mov R1, A
RET

;*****************************************************************************
; FUNCTION_NAME: __API_FLASH_ENTRY_POINT
;*****************************************************************************
__API_FLASH_ENTRY_POINT:
  PUSH  AR2
  PUSH  AR4
  PUSH  AR6
  LCALL 0FFF0h
  POP AR6
  POP AR4
  POP AR2
RET


;*****************************************************************************
;*****************************************************************************
; CAUTION !!!! 
; The  function __API_FILL_FF_PAGE must be located 
; in the lower 31Kbytes code of the user flash code memory 
;*****************************************************************************
CSEG AT 100h

;*****************************************************************************
; FUNCTION_NAME: __API_FILL_FF_PAGE
;*****************************************************************************
__API_FILL_FF_PAGE:
	MOV	R1, A
	MOV	FCON,#08h		;map MOVX to col latch
	MOV	A, #0ffh
fill_col_latch:
	MOVX	@DPTR,A			;write the column latch
	INC 	DPTR			;INC to next byte
	DJNZ	R1,fill_col_latch	;loop for all bytes
	MOV	FCON,#50h	
	MOV 	FCON,#0A0h		;flash write

RET



END




